#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_level1 0
#property  indicator_color1  LightSeaGreen
#property  indicator_color2  Red
#property  indicator_color3  DarkGray
#property  indicator_color4  DarkGray
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int MACDShift = 0;
extern int OsMAShift = 0;
extern bool HistogramLine = true;

double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];
int init()
  {
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexShift(0,MACDShift);
   SetIndexShift(1,MACDShift);
   SetIndexShift(2,OsMAShift);
   SetIndexShift(3,OsMAShift);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexDrawBegin(2,SignalSMA);
   SetIndexDrawBegin(3,SignalSMA);
   IndicatorBuffers(4);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   if(!SetIndexBuffer(0,ind_buffer1) && 
      !SetIndexBuffer(1,ind_buffer2) &&
      !SetIndexBuffer(2,ind_buffer3) &&
      !SetIndexBuffer(3,ind_buffer4))
      Print("cannot set indicator buffers!");
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")" );
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);    
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,MODE_SMA,i);  
   for(i=0; i<limit; i++)
      ind_buffer3[i]=ind_buffer1[i]-ind_buffer2[i];
   for(i=0; i<limit; i++)
      if(HistogramLine == true) ind_buffer4[i]=ind_buffer1[i]-ind_buffer2[i];
   return(0);
  }